---------------------------------------- 
-- Layout Code ------------------------- 
----------------------------------------  

-- In here, all the window elements get 
-- created and positioned. This code is
-- pretty much standalone and should not
-- include any complicated handlers or
-- dependencies. It simply draws a window!

----------------------------------------  
----------------------------------------  
----------------------------------------  

function CreateLayout(Version,OnCloseHandler)
	MainForm = Obj.Create("TForm")
	MainForm.Left = 320
	MainForm.Top = 320
	MainForm.Width = 600
	MainForm.Height = 350
	MainForm.Font.Name = "Arial"
	MainForm.Font.Size = 8
	MainForm.OnClose = OnCloseHandler
	MainForm.Caption = Version

	do -- MainForm's children:

		BottomPanel = Obj.Create("TPanel")
		BottomPanel.Height = 16
		BottomPanel.BevelOuter = 0
		BottomPanel.Align = C.alBottom
		BottomPanel.Parent = MainForm

		BottomLabel = Obj.Create("TLabel")
		BottomLabel.Top = 1
		BottomLabel.Left = 4
		BottomLabel.Parent = BottomPanel

		TabControl = Obj.Create("TTabControl")
		TabControl.Align = C.alClient
		TabControl.HotTrack = true
		TabControl.Parent = MainForm

		do -- TabControl's children:

			VarPanel = Obj.Create("TPanel")
			VarPanel.Width = 150
			VarPanel.BevelOuter = 0
			VarPanel.BevelInner = 0
			VarPanel.Align = C.alRight
			VarPanel.Parent = TabControl

			VarSplitter = Obj.Create("TSplitter")
			VarSplitter.Align = C.alRight
			VarSplitter.AutoSnap = false
			VarSplitter.Parent = TabControl

			MainPanel = Obj.Create("TPanel")
			MainPanel.Font.Name = "Courier New"
			MainPanel.Font.Size = 10
			MainPanel.BevelOuter = 0
			MainPanel.Align = C.alClient
			MainPanel.Parent = TabControl

			do -- MainPanel's children:

				OutputPanel = Obj.Create("TPanel")
				OutputPanel.Height = 72
				OutputPanel.BevelOuter = 0
				OutputPanel.BevelInner = 0
				OutputPanel.Align = C.alBottom
				OutputPanel.Parent = MainPanel

				OutputSplitter = Obj.Create("TSplitter")
				OutputSplitter.Align = C.alBottom
				OutputSplitter.AutoSnap = false
				OutputSplitter.Parent = MainPanel

				ScriptPanel = Obj.Create("TPanel")
				ScriptPanel.BevelOuter = 0
				ScriptPanel.BevelInner = 0
				ScriptPanel.Align = C.alClient
				ScriptPanel.Parent = MainPanel
			end
		end
	end

	dofile("wndpos.cfg",false)
	MainForm.Show()
end

----------------------------------------

function FreeLayout()
	if MainForm.WindowState<2 then
		SaveData("wndpos.cfg",
			VarToData("MainForm.Left")..
			VarToData("MainForm.Top")..
			VarToData("MainForm.Width")..
			VarToData("MainForm.Height")..
			VarToData("OutputPanel.Height")..
			VarToData("VarPanel.Width"))
	end

	Obj.Free(ScriptPanel)
	Obj.Free(OutputSplitter)
	Obj.Free(OutputPanel)

	Obj.Free(MainPanel)
	Obj.Free(VarSplitter)
	Obj.Free(VarPanel)

	Obj.Free(TabControl)
	Obj.Free(BottomLabel)
	Obj.Free(BottomPanel)

	Obj.Free(MainForm)
end
